package com.sky.activate.controller;

import com.sky.activate.entity.Device;
import com.sky.activate.service.VerifysService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@RestController
@RequestMapping("/verify")
public class VerifysController {


    @Autowired
    private VerifysService verifysService;

    public SimpleDateFormat formatterDD = new SimpleDateFormat("yyyy-MM-dd");
    private static List<Device> devices = new ArrayList<>();
    // 成功
    private int SUCCEED = 200;
    // 未授权
    private int NO_ACTIVATE = 201;
    // 字段错误
    private int PARAM_ERROR = 202;
    // 过期失效
    private int LOSE_ACTIVATE = 300;


    @RequestMapping("/testStr")
    public  String testStr(){
        return verifysService.testStr();
    }


    @PostMapping("/verify")
    public int verify(HttpServletRequest request){
        String key = request.getParameter("key");
        String address = request.getParameter("address");
        Date dateNow = new Date(System.currentTimeMillis());

        if(StringUtils.isEmpty(key) || StringUtils.isEmpty(address)){
            return PARAM_ERROR;
        }

        if(devices.size() < 1){
            devices = verifysService.selectAll();
        }

        if(devices.size() == 0){
            return NO_ACTIVATE;
        }

        for(int i = 0; i < devices.size(); i ++){
            devices.get(i).setKeyMD5(
                    DigestUtils.md5DigestAsHex(
                            devices.get(i).getKey().getBytes()));
        }
        boolean isActivate = false;
        for(Device device : devices){
            if(device.getKeyMD5().equals(key) ){
                if(device.getAddress().equals("0.0.0.0") || device.getAddress().equals(address)){
                    if(device.getLoseDate().getTime() > dateNow.getTime()){
                        isActivate = true;
                    }
                }
            }
        }

        if(isActivate){
            return SUCCEED;
        } else {
            return LOSE_ACTIVATE;
        }

    }

}
